-- phpMyAdmin SQL Dump
-- version 2.8.1
-- http://www.phpmyadmin.net
-- 
-- Host: localhost
-- Generation Time: Jan 25, 2007 at 11:08 AM
-- Server version: 5.0.24
-- PHP Version: 5.1.6
-- 
-- Database: `platforms`
-- 

-- --------------------------------------------------------

DROP TABLE IF EXISTS `pflikes`;
DROP TABLE IF EXISTS `pfusers`;
DROP TABLE IF EXISTS `pfrelations`;

-- --------------------------------------------------------

-- 
-- Table structure for table `pfusers`
-- 

CREATE TABLE `pfusers` (
  `ID` int(11) NOT NULL auto_increment,
  `LOGIN` char(32) collate latin1_general_ci NOT NULL,
  `PWDHASH` char(32) collate latin1_general_ci NOT NULL,
  `FULLNAME` char(128) collate latin1_general_ci NOT NULL,
  `EMAIL` char(128) collate latin1_general_ci NOT NULL,
  `CITY` char(128) collate latin1_general_ci default NULL,
  `COUNTRY` char(64) collate latin1_general_ci NOT NULL,
  `MOTTO` char(128) collate latin1_general_ci default NULL,
  `SECMOTTO` char(128) collate latin1_general_ci default NULL,
  `LATITUDE` float default NULL,
  `LONGITUDE` float default NULL,
  `PRIMENA` tinyint(4) default NULL,
  `SECENA` tinyint(4) default NULL,
  `REGISTRATION` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `TTT_ANSWERS` char(40) collate latin1_general_ci default NULL,
  `TTT_FULL` char(32) collate latin1_general_ci default NULL,
  `TTT` char(4) collate latin1_general_ci default NULL,
  `TTT_TESTTIME` timestamp NULL default NULL,
  `LAST_LOGIN` timestamp NULL default NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `LOGIN` (`LOGIN`),
  KEY `COUNTRY` (`COUNTRY`),
  KEY `main` (`ID`,`REGISTRATION`,`TTT_TESTTIME`,`COUNTRY`,`TTT`,`PRIMENA`,`SECENA`),
  KEY `MOTTO` (`MOTTO`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;
-- ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='Platform Contest Main User Table' AUTO_INCREMENT=2 ;

-- --------------------------------------------------------

-- 
-- Table structure for table `pflikes`
-- 

CREATE TABLE `pflikes` (
  `ID` int(11) NOT NULL auto_increment,
  `USERID` int(11) NOT NULL,
  `TYPE` enum('0','1') collate latin1_general_ci NOT NULL,
  `TEXT` char(128) collate latin1_general_ci NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `main` (`TYPE`,`USERID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- FOREIGN KEY (`USERID`) REFERENCES pfusers(ID)  ON DELETE CASCADE
-- ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='List of Likes and Dislikes per User' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `pflikes`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `pfrelations`
-- 

CREATE TABLE `pfrelations` (
  `ID` int(11) NOT NULL auto_increment,
  `USERID` int(11) NOT NULL,
  `LINKID` int(11) NOT NULL,
  `STATUS` enum('RCD','ACC','DEC') collate latin1_general_ci default NULL,
  `LASTCHANGE` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ID`),
  KEY `main` (`USERID`,`LINKID`,`STATUS`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci COMMENT='Platforms Link Table for contacts' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `pfrelations`
-- 

INSERT INTO `pfrelations` VALUES (1, 1, 2, 'RCD', '2007-01-26 12:26:52');
INSERT INTO `pfrelations` VALUES (2, 3, 1, 'ACC', '2007-01-26 12:26:52');

-- 
-- Dumping data for table `pfusers`
-- 

INSERT INTO `pfusers` VALUES (1, 'admin', md5('gof0r1t'), 'Lars Jankowfsky', 'lars@oxid-esales.com', 'Nurnberg', 'germany', 'PHP rulez', 'PHP still rulez', 49.45, 11.07, 4, 8, '2006-08-01 12:00', 'spnfjiteitepefnfejpefjijffjsnfifnispjssn', 'i+0s+0f+6j+2', 'isfj', '0000-00-00 00:00', '2006-08-01 12:00');
INSERT INTO `pfusers` VALUES (2, 'test', md5('123456'), 'Goranka Jankowfsky', 'gogi@oxid-esales.com', 'Freiburg', 1, 'PHP rulez', 'PHP still rulez', 47.694974, 9.049988, 2, 4, '0000-00-00 00:00', '', '', '', '0000-00-00 00:00', '0000-00-00 00:00');
INSERT INTO `pfusers` VALUES (3, 'nachbar', md5('123456'), 'Nachbar Testuser', 'text@example.com', 'Frth', 1, 'PHP rulez', 'PHP still rulez', 49.479948, 10.983925, 3, 2, '0000-00-00 00:00', '', '', '', '0000-00-00 00:00', '0000-00-00 00:00');

